//-----------------------------------------------------------
//
//-----------------------------------------------------------
class AdvancedFlakCannon extends UT_FlakCannon;

function Fire( float Value )
{
	local Vector Start, X,Y,Z;
	local Bot B;
	local Pawn P;

	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		bCanClientFire = true;
		bPointing=True;
		Start = Owner.Location + CalcDrawOffset();
		B = Bot(Owner);
		P = Pawn(Owner);
		P.PlayRecoil(FiringSpeed);
		Owner.MakeNoise(2.0 * P.SoundDampening);
		AdjustedAim = P.AdjustAim(AltProjectileSpeed, Start, AimError, True, bWarnTarget);
		GetAxes(AdjustedAim,X,Y,Z);
		Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		Spawn( class 'UTChunk1',, '', Start, AdjustedAim);
		Spawn( class 'UTChunk2',, '', Start - Z, AdjustedAim);
		Spawn( class 'UTChunk3',, '', Start + 2 * Y + Z, AdjustedAim);
		Spawn( class 'UTChunk4',, '', Start - Y, AdjustedAim);
		Spawn( class 'UTChunk1',, '', Start + 2 * Y - Z, AdjustedAim);
		Spawn( class 'UTChunk2',, '', Start, AdjustedAim);
		Spawn( class 'mh4ever.bluechunk',, '', Start, AdjustedAim);
		Spawn( class 'mh4ever.bluechunk',, '', Start - Z, AdjustedAim);
		Spawn( class 'mh4ever.bluechunk',, '', Start + 2 * Y + Z, AdjustedAim);
		Spawn( class 'mh4ever.bluechunk',, '', Start - Y, AdjustedAim);
		Spawn( class 'mh4ever.bluechunk',, '', Start + 2 * Y - Z, AdjustedAim);
		Spawn( class 'mh4ever.bluechunk',, '', Start, AdjustedAim);

		// lower skill bots fire less flak chunks
		if ( (B == None) || !B.bNovice || ((B.Enemy != None) && (B.Enemy.Weapon != None) && B.Enemy.Weapon.bMeleeWeapon) )
		{
			Spawn( class 'UTChunk3',, '', Start + Y - Z, AdjustedAim);
			Spawn( class 'UTChunk4',, '', Start + 2 * Y + Z, AdjustedAim);
		}
		else if ( B.Skill > 1 )
			Spawn( class 'UTChunk3',, '', Start + Y - Z, AdjustedAim);

		ClientFire(Value);
		GoToState('NormalFire');
	}
}

function AltFire( float Value )
{
	local Vector Start, X,Y,Z;

	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		Pawn(Owner).PlayRecoil(FiringSpeed);
		bPointing=True;
		bCanClientFire = true;
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Start = Owner.Location + CalcDrawOffset();
		Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);
		Spawn(class'mh4ever.superflakshell',,, Start,AdjustedAim);
		ClientAltFire(Value);
		GoToState('AltFiring');
	}
}

defaultproperties
{
     PickupAmmoCount=20
     AltProjectileClass=Class'MH4ever.SuperFlakShell'
     PickupMessage="You got the Advanced Flak Cannon."
}
