//=============================================================================
// MultiSkyNitrogenZone.
//
// by Steve Nabors
//
// www.planetunreal.com/slick
// slickWilly@planetunreal.com
//
// To use just create your skyboxes and give them each their own
// SkyZoneInfo.  When you place your SkyZoneInfo,  give it a tag name.
//
// Now place this zoneinfo in place of the normal NitrogenZone actor in
// the parts of the map where you have Fake BackDrops.
//
// Once you place this ZoneInfo in your level you will give it the
// the name of the skybox tag in it's event tag.  In the 2d view you
// will then see a link line to your skyzoneinfo.  Once linked up
// all fakebackdrop textures in the zone with this actor will point
// to the proper skybox info.  
//
//=============================================================================
class MultiSkyNitrogenZone expands ZoneInfo;

// When an actor enters this zone.
event ActorEntered( actor Other )
{
	Super.ActorEntered(Other);
	if ( Other.IsA('Pawn') && Pawn(Other).bIsPlayer )
	{
		Pawn(Other).UnderWaterTime = -1.0;
		Pawn(Other).WaterSpeed *= 2;
	}
}

// When an actor leaves this zone.
event ActorLeaving( actor Other )
{
	Super.ActorLeaving(Other);
	if ( Other.IsA('Pawn') && Pawn(Other).bIsPlayer )
	{
		Pawn(Other).UnderWaterTime = Pawn(Other).Default.UnderWaterTime;
		Pawn(Other).WaterSpeed *= 0.5;
	}
}

simulated function LinkToSkybox()
{
	local skyzoneinfo Sky;

	Super.LinkToSkybox();

	foreach AllActors( class 'SkyZoneInfo', Sky, Event )
	{
		SkyZone = Sky;
	}
}

defaultproperties
{
     DamagePerSec=20
     DamageType=Frozen
     bWaterZone=True
     bPainZone=True
     ViewFog=(X=0.011719,Y=0.039063,Z=0.046875)
}
