//=============================================================================
// MultiSkyZoneInfo.
// by Steve Nabors
//
// www.planetunreal.com/slick
// slickWilly@planetunreal.com
//
// To use just create your skyboxes and give them each their own
// SkyZoneInfo.  When you place your SkyZoneInfo,  give it a tag name.
//
// Now place this zoneinfo in place of the normal ZoneInfo actor in
// the parts of the map where you have Fake BackDrops.
// You can use this ZoneInfo in place of any normal zone or any of the
// Liquid zones like Water and Lava.  It can't be used in place
// of any scripted zones like the NitrogenZone, VacuumZone, PressureZone,
// etc.  Liquid zones have no special code other than the default
// zoneinfo settings have been changed for you.  You can in reality
// take a normal zoneinfo and change it into a water, Lava, Tar zone
// just by adjusting the settings.
//
// Once you place this ZoneInfo in your level you will give it the
// the name of the skybox tag in it's event tag.  In the 2d view you
// will then see a link line to your skyzoneinfo.  Once linked up
// all fakebackdrop textures in the zone with this actor will point
// to the proper skybox info.  
//
//=============================================================================

class MultiSkyZoneInfo expands ZoneInfo;

simulated function LinkToSkybox()
{
	local skyzoneinfo Sky;

	Super.LinkToSkybox();

	foreach AllActors( class 'SkyZoneInfo', Sky, Event )
	{
		SkyZone = Sky;
	}
}

defaultproperties
{
}
