//-----------------------------------------------------------
//
//-----------------------------------------------------------
class PinballRocket expands RocketMk2;

var int NumWallHits;
var bool bCanHitInstigator, bHitWater;

auto state Flying
{
	simulated function ProcessTouch (Actor Other, Vector HitLocation)
	{
       if (Other == instigator && !Other.IsA('Projectile') && (NumWallHits == 0)) ;

	   else
	        Explode(hitLocation,Normal(HitLocation-Other.Location));
	        PlaySound(ImpactSound, SLOT_Misc, 2.0);
	}

	simulated function ZoneChange( Zoneinfo NewZone )
	{
		local Splash w;

		if (!NewZone.bWaterZone || bHitWater) Return;

		bHitWater = True;
		if ( Level.NetMode != NM_DedicatedServer )
		{
			w = Spawn(class'Splash',,,,rot(16384,0,0));
			w.DrawScale = 0.5;
			w.RemoteRole = ROLE_None;
		}
		Velocity=0.6*Velocity;
	}

	simulated function SetRoll(vector NewVelocity)
	{
		local rotator newRot;

		newRot = rotator(NewVelocity);
		SetRotation(newRot);
	}

	simulated function HitWall (vector HitNormal, actor Wall)
	{
		local vector Vel2D, Norm2D;
		local UT_SpriteBallExplosion s;

		bCanHitInstigator = true;
		PlaySound(ImpactSound, SLOT_Misc, 2.0);
		LoopAnim('Spin',1.0);
		if ( (Mover(Wall) != None) && Mover(Wall).bDamageTriggered )
		{
			if ( Role == ROLE_Authority )
				Wall.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), MyDamageType);
			Destroy();
			return;
		}
		NumWallHits++;
		SetTimer(0, False);
		MakeNoise(0.3);
		if ( NumWallHits > 6 )
			Destroy();

		if ( NumWallHits == 1 )
		{
			Vel2D = Velocity;
			Vel2D.Z = 0;
			Norm2D = HitNormal;
			Norm2D.Z = 0;
			Norm2D = Normal(Norm2D);
			Vel2D = Normal(Vel2D);
			if ( (Vel2D Dot Norm2D) < -0.999 )
			{
				HitNormal = Normal(HitNormal + 0.6 * Vel2D);
				Norm2D = HitNormal;
				Norm2D.Z = 0;
				Norm2D = Normal(Norm2D);
				if ( (Vel2D Dot Norm2D) < -0.999 )
				{
					if ( Rand(1) == 0 )
						HitNormal = HitNormal + vect(0.05,0,0);
					else
						HitNormal = HitNormal - vect(0.05,0,0);
					if ( Rand(1) == 0 )
						HitNormal = HitNormal + vect(0,0.05,0);
					else
						HitNormal = HitNormal - vect(0,0.05,0);
					HitNormal = Normal(HitNormal);
				}
			}
		}
        Spawn(class'Botpack.BlastMark',,,Location, rotator(HitNormal));
		s = spawn(class'UT_SpriteBallExplosion',,,Location + HitNormal*16);
            s.RemoteRole = ROLE_None;
 		    BlowUp(Location);
		Velocity -= 2 * (Velocity dot HitNormal) * HitNormal;
		timer();
		SetRoll(Velocity);
	}

	function BlowUp(vector HitLocation)
	{
		HurtRadius(45,150.0, MyDamageType, MomentumTransfer, HitLocation );
		MakeNoise(1.0);
	}

	function SetUp()
	{
		local vector X;

		X = vector(Rotation);
		Velocity = Speed * X;     // Impart ONLY forward vel
		if (Instigator.HeadRegion.Zone.bWaterZone)
			bHitWater = True;
	}

	function BeginState()
	{
		local vector Dir;

		Dir = vector(Rotation);
		Velocity = speed * Dir;
		Acceleration = Dir * 50;
		PlayAnim( 'Wing', 0.2 );
		if (Region.Zone.bWaterZone)
		{
			bHitWater = True;
			Velocity=0.6*Velocity;
		}
	}

	simulated function Timer()
	{
	  local ut_SpriteSmokePuff b;
	  bCanHitInstigator = true;

    if ( Region.Zone.bWaterZone || (Level.NetMode == NM_DedicatedServer) )
		Return;

	if ( Level.bHighDetailMode )
	{
		if ( Level.bDropDetail || ((NumExtraRockets > 0) && (FRand() < 0.5)) )
			Spawn(class'LightSmokeTrail');
		else
			Spawn(class'UTSmokeTrail');
		SmokeRate = 152/Speed;
	}
	else
	{
		SmokeRate = 0.15 + FRand()*(0.01+NumExtraRockets);
		b = Spawn(class'ut_SpriteSmokePuff');
		b.RemoteRole = ROLE_None;
	}
	SetTimer(SmokeRate, false);
	}
}

defaultproperties
{
     LifeSpan=10.000000
}
