// =============================================================================
// Author   : Boom-Boy
// Homepage : http://ut-lity.cool.ne.jp/
//
// Version  : 1.0
// =============================================================================

class SniperTentacle extends ASMDShockTentacle;

var(SniperTentacle) float HeadShotRate;

var name MyDamageType;
var name AltDamageType;

function PlayRangedAttack() {

	local vector HitLocation, HitNormal, StartTrace, EndTrace, X, Y, Z;
	local rotator AdjustedAim;
	local actor Other;
	local bool bTryingHeadShot;

	MakeNoise(1.0);
	GetAxes(ViewRotation, X, Y, Z);
	StartTrace = Location + CollisionHeight * vect(0, 0, -1.2);
	EndTrace = StartTrace + 1.0 * (FRand() - 0.5) * Y * 1000
		+ 1.0 * (FRand() - 0.5) * Z * 1000;

	AdjustedAim = AdjustAim(1000000, StartTrace, AimErr, bLeadTarget, bWarnTarget);
	EndTrace += (10000 * vector(AdjustedAim));
	Other = TraceShot(HitLocation, HitNormal, EndTrace, StartTrace);

	if (Other == Level) {
		Spawn(class'UT_HeavyWallHitEffect', , , HitLocation + HitNormal, Rotator(HitNormal));
	} else if (Other != None && Other != Self && Other.bIsPawn) {
		Other.PlaySound(Sound 'ChunkHit', , 4.0, , 100);
		bTryingHeadShot = (FRand() < HeadShotRate);
		if (bTryingHeadShot) {
			HitLocation.Z = Other.Location.Z + (0.62 * (Other.CollisionHeight + 2));
			Other.TakeDamage(100, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);
		} else {
			Other.TakeDamage(45, Pawn(Owner), HitLocation, 35000 * X, MyDamageType);
		}
	} else if (Other != None && Other != Self && !Other.bIsPawn && !Other.IsA('Carcass')) {
		Spawn(class'UT_SpriteSmokePuff', , , HitLocation + HitNormal * 9);
	}

	PlayAnim('Shoot', Refire);
}

defaultproperties
{
     HeadShotRate=0.500000
     MyDamageType=shot
     AltDamageType=Decapitated
}
