//-----------------------------------------------------------
//
//-----------------------------------------------------------
class powershockrifle expands ShockRifle;

#exec texture import name=redASMD_t file=d:\unrealtournament\rainbowshockrifle\ASMD_t.pcx

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local int i;
	local PlayerPawn PlayerOwner;

	if (Other==None)
	{
		HitNormal = -X;
		HitLocation = Owner.Location + X*10000.0;
	}

	PlayerOwner = PlayerPawn(Owner);
	if ( PlayerOwner != None )
		PlayerOwner.ClientInstantFlash( -0.4, vect(450, 190, 650));
    HurtRadius(hitDamage / 2,110.0, MyDamageType,6000, HitLocation );
	SpawnEffect(HitLocation, Owner.Location + CalcDrawOffset() + (FireOffset.X + 20) * X + FireOffset.Y * Y + FireOffset.Z * Z);

	if ( ShockProj(Other)!=None )
	{
		AmmoType.UseAmmo(2);
		ShockProj(Other).SuperExplosion();
	}
	else
		Spawn(class'redwave',,, HitLocation+HitNormal*8,rotator(HitNormal));
        Spawn(class'redshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));

	if ( (Other != self) && (Other != Owner) && (Other != None) )
		Other.TakeDamage(HitDamage, Pawn(Owner), HitLocation, 60000.0*X, MyDamageType);
}


function SpawnEffect(vector HitLocation, vector SmokeLocation)
{
	local SuperShockBeam Smoke,shock;
	local Vector DVector;
	local int NumPoints;
	local rotator SmokeRotation;

	DVector = HitLocation - SmokeLocation;
	NumPoints = VSize(DVector)/135.0;
	if ( NumPoints < 1 )
		return;
	SmokeRotation = rotator(DVector);
	SmokeRotation.roll = Rand(65535);

	Smoke = Spawn(class'SuperShockBeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
}

simulated function PlayFiring()
{
	PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*4.0);
	LoopAnim('Fire1', 0.25 + 0.25 * FireAdjust,0.05);
}

simulated function PlayAltFiring()
{
	PlayOwnedSound(AltFireSound, SLOT_None,Pawn(Owner).SoundDampening*4.0);
	LoopAnim('Fire2',0.4 + 0.4 * FireAdjust,0.05);
}

defaultproperties
{
     hitdamage=100
     AmmoName=Class'MH4ever.Powershockcore'
     PickupAmmoCount=50
     AltProjectileClass=Class'MH4ever.powershockproj'
     PickupMessage="You got the Power Shock Rifle."
     ItemName="Power Shock Rifle"
     PlayerViewMesh=LodMesh'Botpack.sshockm'
     ThirdPersonMesh=LodMesh'Botpack.SASMD2hand'
     MultiSkins(1)=Texture'MH4ever.redASMD_t'
}
